'use strict'

/*
Currently an closure to render the Cuddly Menu 'carebear' sprites.

This will probably at some point grow into an object where you can load different waveforms -
see sineScrollerFunctions below. But will have to do for now, I need this Cuddly Menu to be
finished!!! 

// Initialize with external resources:
sineSprites.init(time, sprites, tileMap, framebuffer)
	time = FruTime object - current time of animation
	sprites = sprites image - IMG element containing sprites
	tileMap = FruTools.Tile object - Tile object that explains sprites tilemap
	framebuffer = destination canvas drawing context (not the canvas object itself)

// Change external resources to use:
sineSprites.change(time, sprites, tileMap, framebuffer)
	// args same as above.

// Animate frame:
sineSprites.go();


http://frutbunn.com  frutbunn@gmail.com (frutbunn)

This work is licensed under the Creative Commons Attribution 4.0 International License. 
To view a copy of this license, visit http://creativecommons.org/licenses/by/4.0/.
*/

var sineSprites = (function() {
	
	var state = {
		time: undefined,
		sprites: undefined,
		tileMap: undefined,
		framebuffer: undefined
	};

	var carebaresSineScroller = {
		LETTER_COUNT: 12,
		ANIMATION_COUNT: 7,
		ANIMATION_DURATION: 8, // must be an even number, due to modulus below
	
		SCROLL_DURATION: 1, // or 2 - do not use other values
		SCROLL_INDEX: .5, // or 1 - do not use other values

		sineScrollerFunctions: [
			// t = current time in seconds
			// i = sprite index (0 onwards etc.)
			// width = width of graphics context to use
			// height = height of graphics context to use
			function(t, i, width, height) {
				var p = new FruTools.Coordinate();

				var speed_x = 25;
				var speed_y = 4.5;
				var spacing_y = .15; 
				var spacing_x = .3;

				width*=.5;
				height*=.25;

				width*=.5;
				height*=.25;

				p.x = ( (i-(carebaresSineScroller.LETTER_COUNT-1)/2)*spacing_x)*width; 
				p.y = (Math.cos( (t-(i*spacing_y) ) * speed_y) * height);

				var spin_x =6.1;
				var o = Math.sin(t*spin_x + i*spin_x*3);
				p.x += o*speed_x;

				p.x*=2.1;
				p.y*=3;

				return p;
			},
			function(t, i, width, height) {
				var p = new FruTools.Coordinate();

				var speed_x = 2.5*.7;
				var speed_y = 5*.7;

				var spacing = .1;

				var twist_speed = 1.6*.7;
				var twist = (Math.sin(t*twist_speed) + Math.cos(t*twist_speed) ) *.75;

				p.x = (Math.sin( (t-(i*spacing) ) * speed_x) * width*1.05);
				p.y = (Math.sin( (t-(i*spacing) ) * speed_y) * height) * twist;

				return p;
			},
			function(t, i, width, height) {
				var p = new FruTools.Coordinate();

				var speed_x = 4;
				var speed_y = 3;

				var spacing = .07;

				var twist_speed = 2;
				var twist = (Math.sin(t*twist_speed) + Math.cos(t*twist_speed) ) *.75;

				p.x = (Math.sin( (t-(i*spacing) ) * speed_x) * width*1.05);
				p.y = (Math.sin( (t-(i*spacing) ) * speed_y) * height) * twist;

				p.x *= Math.cos((t-(i))*.25);

				return p;
			},
			function(t, i, width, height) {
				var p = new FruTools.Coordinate();

				var speed_x = 4*.7;
				var speed_y = 3*.7;

				var spacing = .07;

				var twist_speed = 2;
				var twist = (Math.sin(t*twist_speed) + Math.cos(t*twist_speed) ) *.73;

				p.x = (Math.sin( (t-(i*spacing) ) * speed_x) * width) * twist;
				p.y = (Math.cos( (t-(i*spacing) ) * speed_y) * height);

				p.y *= Math.sin((t-(i))*.25);

				return p;
			},
			function(t, i, width, height) {
				var p = new FruTools.Coordinate();

				var speed_x = 1;
				var speed_y = 1.2;
		
				var twist_speed_y = 4;
				var twist_speed_x = 4.5;

				var spacing = .1;

				var twist_y = (1 - (Math.sin((t-(i*spacing))*twist_speed_y)))*.52;
				var twist_x = (1 - (Math.sin((t-(i*spacing))*twist_speed_x)))*.52;

				p.x = (Math.sin( (t-(i*spacing) ) * speed_x) * width) * twist_x;
				p.y = (Math.cos( (t-(i*spacing) ) * speed_y) * height) * twist_y;

				return p;
			},
			function(t, i, width, height) {
				var p = new FruTools.Coordinate();

				var speed_x = 3.5*.7;
				var speed_y = 3.5*.7;

				var spacing = .1;

				height*=.9;

				var twist_speed = 3*.5;
				var twist = (Math.sin(t*twist_speed) + Math.cos(t*twist_speed) ) *.82;

				p.x = (Math.cos( (t-(i*spacing) ) * speed_x) * width*1.05);
				p.y = (Math.sin( (t-(i*spacing) ) * speed_y) * height) * twist;

				return p;
			},
			function(t, i, width, height) {
				var p = new FruTools.Coordinate();

				var speed_x = 4*.7;
				var speed_y = 3*.7;

				var spacing = .1;
		
				var twist_speed = 3;
				var twist = (Math.sin(t*twist_speed) + Math.cos(t*twist_speed) ) *.75;

				p.x = (Math.cos( (t-(i*spacing) ) * speed_x) * width*1.04); 
				p.y = (Math.sin( (t-(i*spacing) ) * speed_y) * height) * twist;

				p.x *= Math.sin((t-(i*spacing))*.5);

				return p;
			}
		]
	};

	function init(time, sprites, tileMap, framebuffer) {
		state.time = time;
		state.sprites = sprites;
		state.tileMap = tileMap;
		state.framebuffer = framebuffer;
	}

	function deriveFromTime(time, duration, min, max) {
		return ( ( (time % duration) * (max - min) ) / duration ) + min;
	}


	function go() {

		var c = carebaresSineScroller;
		var t = state.time.seconds.current;

		if (t>=(c.ANIMATION_COUNT * (c.ANIMATION_DURATION + c.SCROLL_DURATION*2) ) ) {
			state.time.reset();
			t = state.time.seconds.current;
		}

		// Make sure have enough space to subtract from time
		t+=c.SCROLL_DURATION;

		var canvas = state.framebuffer.canvas;
		var timerCycle = Math.floor(deriveFromTime(t, c.ANIMATION_DURATION+(c.SCROLL_DURATION*2)
		 , 0, c.ANIMATION_DURATION+(c.SCROLL_DURATION*2) ) );

		var xDisplacement = 0;

		if (timerCycle<=(c.SCROLL_DURATION-c.SCROLL_INDEX) ) {
			// Scroll off
			xDisplacement = 0 - canvas.width * deriveFromTime(t, c.SCROLL_DURATION, 0, 1);
		} else if (timerCycle <=(c.SCROLL_DURATION+c.SCROLL_DURATION-c.SCROLL_INDEX) ) {
			// Scroll on
			xDisplacement = canvas.width * deriveFromTime(t, c.SCROLL_DURATION, 1, 0);
		} 

		var animation = (Math.floor( (t-c.SCROLL_DURATION) / 
		 (c.ANIMATION_DURATION+(c.SCROLL_DURATION*2)) ) % c.ANIMATION_COUNT);

		var centreOfScreen = new FruTools.Coordinate(canvas.width*.5, canvas.height*.5);
		var CENTER_OF_SPRITE = new FruTools.Coordinate(32/2, 20/2);

		var width = centreOfScreen.x*.9;
		var height = centreOfScreen.y*.88;

		for(var i=0; i<c.LETTER_COUNT; i++) {
			var x=0, y=0;

			var p = c.sineScrollerFunctions[animation](t, i, width, height);

			p.x += centreOfScreen.x;
			p.y += centreOfScreen.y;

			p.x = Math.floor(p.x + xDisplacement);
			p.y = Math.floor(p.y);

			p.x -= CENTER_OF_SPRITE.x;
			p.y -= CENTER_OF_SPRITE.y;

			var s = state.tileMap.position(i);

			state.framebuffer.drawImage(
				state.sprites,
				s.x, s.y, s.w, s.h,
				p.x, p.y, s.w, s.h
			);

		}


	}

	return {
		init: init,
		change: init,
		go:go
	}

})();
